var http = require('../util/http.js').func;
var cache = require('../cache');

exports.required = ['userId', 'assetId'];
exports.option = ['assetType'];

function hasAsset (userId, assetId, assetType) {
  var httpOpt = {
    url: '//inventory.roblox.com/v1/users/' + userId + '/items/' + assetType + '/' + assetId,
    options: {
      resolveWithFullResponse: true,
      method: 'GET'
    }
  };
  return http(httpOpt)
  .then(function (res) {
    if (res.statusCode === 200) {
      return JSON.parse(res.body);
    } else {
      throw new Error('Asset does not exist');
    }
  });
}

exports.func = function (args) {
  var assetId = args.assetId;
  var userId = args.userId;
  var assetType = args.assetType || "Asset";
  return hasAsset(userId, assetId, assetType);
};
