var http = require('../util/http.js').func;

exports.required = ['assetId'];
exports.optional = [];

function getAssetOwners(assetId, limit, sort, cursor) {
  var url = "//inventory.roblox.com/v1/assets/" + assetId + "/owners?";

  if (limit) url += "&limit=" + limit;
  if (cursor) url += "&cursor=" + cursor;
  if (sort) url += "&sortOrder=" + sort;

  var httpOpt = {
    url: url,
    options: {
      resolveWithFullResponse: true,
      method: 'GET'
    }
  };
  return http(httpOpt)
  .then(function (res) {
    if (res.statusCode === 200) {
      return JSON.parse(res.body);
    } else {
      throw new Error("Couldn't fetch asset owners!");
    }
  });
}

exports.func = function (args) {
  var assetId = args.assetId;
  var limit = args.limit;
  var cursor = args.cursor;
  var sort = args.sort;
  var page = args.page;
  if (page) {
    function CheckCursor(currentPage, nextCursor) {
      var promise = getAssetOwners(assetId, limit, sort, nextCursor);
      if (page > currentPage) {
        return promise.then(function(data) {
          return CheckCursor(currentPage + 1, data.nextPageCursor);
        });
      } else {
        return promise;
      }
    }
    return CheckCursor(1);
  } else {
    return getAssetOwners(assetId, limit, sort, cursor);
  }
}
