var shortPoll = require('../util/shortPoll.js').func;
var getAssetOwners = require('./getAssetOwners.js').func;
var resolveDate = require('../util/resolveDate.js').func;

exports.required = ['assetId'];
exports.optional = [];

exports.func = function (args) {
  var assetId = args.assetId;
  return shortPoll({
    getLatest: function (latest) {
      return getAssetOwners({assetId: assetId, sort: "Desc"})
      .then(function (owners) {
        var given = [];
        for (let i = owners.data.length - 1; i >= 0; i--) {
          let owner = owners.data[i];
          let id = (new Date(owner.created));
          if (id > latest) {
            latest = id;
            given.push(owner);
          }
        }
        return {
          latest: latest,
          data: given
        }
      });
    },
    delay: 'onAssetPurchase',
    timeout: -1
  });
};
