var http = require('../util/http.js').func;
var getGeneralToken = require('../util/getGeneralToken.js').func;

exports.required = ['group', 'id'];
exports.optional = ['page', 'jar'];

function deleteWallPost (jar, xcsrf, group, post) {
  return http({
    url: 'https://groups.roblox.com/v1/groups/' + group + '/wall/posts/' + post,
    options: {
      method: 'DELETE',
      jar: jar,
      resolveWithFullResponse: true,
      headers: {
        'X-CSRF-TOKEN': xcsrf
      }
    }
  })
  .then(function (res) {
    if (res.statusCode !== 200) {
      throw new Error('Delete wall post failed, make sure you have permission to manage the wall');
    }
  });
}

function runWithToken (args) {
  var jar = args.jar;
  return getGeneralToken({jar: jar})
  .then(function (xcsrf) {
    return deleteWallPost(jar, xcsrf, args.group, args.id).catch(function(e) { console.log(e); });
  }).catch(function(e) { console.log(e) });
}

exports.func = function (args) {
  return runWithToken(args);
};
