var shortPoll = require('../util/shortPoll.js').func;
var getWall = require('./getWall.js').func;

exports.required = ['group'];
exports.optional = ['view', 'jar'];

exports.func = function (args) {
  var group = args.group;
  var jar = args.jar;
  var view = args.view;
  return shortPoll({
    getLatest: function (latest) {
      return getWall({group: group, jar: jar, view: view, page: 1})
      .then(function (wall) {
        var posts = wall.posts;
        var given = [];
        for (let i = posts.length - 1; i >= 0; i--) {
          let post = posts[i];
          let id = post.id;
          if (id > latest) {
            latest = id;
            if (view) {
              post.view = wall.views[post.parent.page];
            }
            given.push(post);
          }
        }
        return {
          latest: latest,
          data: given
        };
      });
    },
    delay: 'onWallPost'
  });
};
