var http = require('../util/http.js').func;
var getGeneralToken = require('../util/getGeneralToken.js').func;

exports.required = ['group', 'message'];
exports.optional = ['jar'];

function post (jar, xcsrf, group, message) {
  return http({
    url: 'https://groups.roblox.com/v1/groups/' + group + '/wall/posts',
    options: {
      method: 'POST',
      jar: jar,
      resolveWithFullResponse: true,
      headers: {
        'X-CSRF-TOKEN': xcsrf
      },
      json: {
        body: message
      },
    }
  })
  .then(function (res) {
    if (res.statusCode !== 200) {
      throw new Error('Delete wall post failed, make sure you have permission to manage the wall');
    }
  });
}

function runWithToken (args) {
  var jar = args.jar;
  return getGeneralToken({jar: jar})
  .then(function (xcsrf) {
    return deleteWallPost(jar, xcsrf, args.group, args.message);
  });
}

exports.func = function (args) {
  return runWithToken(args);
};
