var http = require('../http.js').func;
var getUsernameFromId = require('./getUsernameFromId.js').func;

exports.required = ['username'];
exports.optional = ['userid', 'jar'];

function getDevForum(args) {
  var httpOpt = {
    url: '//devforum.roblox.com/users/' + args.username + '.json',
    options: {
      resolveWithFullResponse: true,
      method: 'GET',
      followRedirect: false
    }
  };
  return http(httpOpt)
  .then(function (res) {
    if (res.statusCode !== 200) {
      throw new Error("Couldn't get user's devforum info.");
    } else {
      var json = JSON.parse(res.body);
      return json.user.trust_level;
    }
  });
};

exports.func = function(args) {
  if (args.userid) {
    return getUsernameFromId(args.userid).then(function(username) {
      args.username = username;
      return getDevForum(args);
    });
  } else {
    return getDevForum(args);
  }
}
