var getHash = require('./getHash.js').func;
var http = require('./http.js').func;
var cache = require('../cache');

exports.optional = ['jar'];

function getGeneralToken (jar) {
  var httpOpt = {
    url: '//api.roblox.com/sign-out/v1',
    options: {
      resolveWithFullResponse: true,
      method: 'POST',
      jar: jar
    }
  };
  return http(httpOpt)
  .then(function (res) {
    var xcsrf = res.headers['x-csrf-token'];
    if (xcsrf) {
      return xcsrf;
    } else {
      throw new Error('Did not receive X-CSRF-TOKEN');
    }
  });
}

exports.func = function (args) {
  var jar = args.jar;
  return cache.wrap('XCSRF', getHash({jar: jar}), function () {
    return getGeneralToken(jar);
  });
};
